Index: ruby/branches/0.5/lib/open_ehr/rm/common/archetyped.rb
===================================================================
--- ruby/branches/0.5/lib/open_ehr/rm/common/archetyped.rb	(revision 291)
+++ ruby/branches/0.5/lib/open_ehr/rm/common/archetyped.rb	(revision 292)
@@ -22,21 +22,21 @@
 
           def item_at_path(path)
-            raise NotImplementError, "item_at_path must be implemented"
+            raise NotImplementedError, "item_at_path must be implemented"
           end
 
           def items_at_path(path)
-            raise NotImplementError, "items_at_path must be implemented"
+            raise NotImplementedError, "items_at_path must be implemented"
           end
 
           def path_exists?(path)
-            raise NotImplementError, "path_exists? must be implemented"
+            raise NotImplementedError, "path_exists? must be implemented"
           end
 
           def path_of_item(item)
-            raise NotImplementError, "path_of_item must be implemented"
+            raise NotImplementedError, "path_of_item must be implemented"
           end
 
-          def path_unique(path)
-            raise NotImplementError, "path_unique must be implemented"
+          def path_unique?(path)
+            raise NotImplementedError, "path_unique? must be implemented"
           end
         end
Index: ruby/trunk/lib/models/tests/rm/test_common.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_common.rb	(revision 291)
+++ ruby/trunk/lib/models/tests/rm/test_common.rb	(revision 292)
@@ -86,12 +86,5 @@
 class RM_Common_Archetyped_Test < Test::Unit::TestCase
   def setup
-<<<<<<< .working
-    @dv_text = OpenEHR::RM::Data_Types::Text::DV_Text.new('Test')
-    @uid_based_id = OpenEHR::RM::Support::Identification::UID_Based_ID.new('rrip::0.0.5')
-    @archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')
-    @template_id = OpenEHR::RM::Support::Identification::Template_ID.new('1.0.1')
-    assert_nothing_raised(Exception){@archetyped = OpenEHR::RM::Common::Archetyped::Archetyped.new(@archetype_id, '1.0.1')}
-    assert_nothing_raised(Exception){@link = OpenEHR::RM::Common::Archetyped::Link.new(OpenEHR::RM::Data_Types::Text::DV_Text.new("generic"), OpenEHR::RM::Data_Types::URI::DV_EHR_URI.new("ehr://test/"),OpenEHR::RM::Data_Types::Text::DV_Text.new("problem"))}
-=======
+
     @dv_text = OpenEhr::RM::DataTypes::Text::DvText.new('Test')
     @uid_based_id = OpenEhr::RM::Support::Identification::UidBasedId.new('rrip::0.0.5')
@@ -100,5 +93,4 @@
     assert_nothing_raised(Exception){@archetyped = OpenEhr::RM::Common::Archetyped::Archetyped.new(@archetype_id, '1.0.1')}
     assert_nothing_raised(Exception){@link = OpenEhr::RM::Common::Archetyped::Link.new(OpenEhr::RM::DataTypes::Text::DvText.new("generic"), OpenEhr::RM::DataTypes::Uri::DvEhrUri.new("ehr://test/"),OpenEhr::RM::DataTypes::Text::DvText.new("problem"))}
->>>>>>> .merge-right.r168
     assert_nothing_raised(Exception){
       @pathable = OpenEhr::RM::Common::Archetyped::Pathable.new }
@@ -153,9 +145,5 @@
     assert_nothing_raised(Exception){@archetyped.template_id = @template_id}
     assert_equal @template_id, @archetyped.template_id
-<<<<<<< .working
-    archetype_id2 = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')
-=======
     archetype_id2 = OpenEhr::RM::Support::Identification::ArchetypeId.new("1.0.2", "biochemistry result_cholesterol", "entry", "ehr_rm", "openehr","cholesterol","0.0.3")
->>>>>>> .merge-right.r168
     assert_nothing_raised(ArgumentError){@archetyped.archetype_id = archetype_id2}
     assert_equal archetype_id2, @archetyped.archetype_id
Index: ruby/trunk/lib/models/tests/rm/test_data_structure.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_data_structure.rb	(revision 291)
+++ ruby/trunk/lib/models/tests/rm/test_data_structure.rb	(revision 292)
@@ -3,10 +3,7 @@
 require 'rm'
 
-<<<<<<< .working
-include OpenEHR::RM::Data_Structures
-=======
 include OpenEHR::RM::Data_Structures
 include OpenEHR::RM::Data_Structures::Item_Structure
->>>>>>> .merge-right.r168
+
 
 class RmDataStructureTest < Test::Unit::TestCase
Index: ruby/trunk/lib/models/tests/rm/test_support.rb
===================================================================
--- ruby/trunk/lib/models/tests/rm/test_support.rb	(revision 291)
+++ ruby/trunk/lib/models/tests/rm/test_support.rb	(revision 292)
@@ -13,18 +13,4 @@
 class RM_Support_Identification_Test < Test::Unit::TestCase
   def setup
-<<<<<<< .working
-    assert_nothing_raised(Exception){@object_id = OpenEHR::RM::Support::Identification::Object_ID.new("0.0.3")}
-    assert_nothing_raised(Exception){@object_ref = OpenEHR::RM::Support::Identification::Object_Ref.new('local', 'ANY', @object_id)}
-    assert_nothing_raised(Exception){@archetype_id = OpenEHR::RM::Support::Identification::Archetype_ID.new('openEHR-EHR-SECTION.physical_examination-prenatal.v2')}
-    assert_nothing_raised(Exception){@terminology_id = OpenEHR::RM::Support::Identification::Terminology_ID.new('ICD10(2003)')}
-    assert_nothing_raised(Exception){@generic_id = OpenEHR::RM::Support::Identification::Generic_ID.new("0.0.3", "openehr")}
-    assert_nothing_raised(Exception){@uid_based_id = OpenEHR::RM::Support::Identification::UID_Based_ID.new('rrip::0.0.3')}
-    assert_nothing_raised(Exception){@hier_object_id = OpenEHR::RM::Support::Identification::Hier_Object_ID.new('0.0.4')}
-    assert_nothing_raised(Exception){@locatable_ref = OpenEHR::RM::Support::Identification::Locatable_Ref.new('unknown', 'PERSON', @uid_based_id, 'data/event[at0001, standing]')}
-    assert_nothing_raised(Exception){@party_ref = OpenEHR::RM::Support::Identification::Party_Ref.new('unknown', 'ORGANISATION', @object_id)}
-    assert_nothing_raised(Exception){@access_group_ref = OpenEHR::RM::Support::Identification::Access_Group_Ref.new('unknown', 'ACCESS_GROUP', @object_id)}
-    assert_nothing_raised(Exception){@version_tree_id = OpenEHR::RM::Support::Identification::Version_Tree_ID.new('1.2.3')}
-    assert_nothing_raised(Exception){@object_version_id = OpenEHR::RM::Support::Identification::Object_Version_ID.new('ABC::DEF::1.2.3')}
-=======
     assert_nothing_raised(Exception){@object_id = OpenEhr::RM::Support::Identification::ObjectId.new("0.0.3")}
     assert_nothing_raised(Exception){@object_ref = OpenEhr::RM::Support::Identification::ObjectRef.new('local', 'ANY', @object_id)}
@@ -39,5 +25,4 @@
     assert_nothing_raised(Exception){@version_tree_id = OpenEhr::RM::Support::Identification::VersionTreeId.new('1.2.3')}
     assert_nothing_raised(Exception){@object_version_id = OpenEhr::RM::Support::Identification::ObjectVersionId.new('ABC::DEF::1.2.3')}
->>>>>>> .merge-right.r168
   end
   
@@ -100,14 +85,4 @@
 
   def test_archetype_id
-<<<<<<< .working
-    assert_equal 'openEHR-EHR-SECTION.physical_examination-prenatal.v2', @archetype_id.value
-    assert_equal 'openEHR-EHR-SECTION', @archetype_id.qualified_rm_entity
-    assert_equal 'openEHR', @archetype_id.rm_originator
-    assert_equal 'EHR', @archetype_id.rm_name
-    assert_equal 'SECTION', @archetype_id.rm_entity
-    assert_equal 'physical_examination', @archetype_id.concept_name
-    assert_equal 'prenatal', @archetype_id.specialisation
-    assert_equal 'v2', @archetype_id.version_id
-=======
     assert_equal "0.0.5", @archetype_id.value
     assert_nothing_raised(Exception){@archetype_id.value = "0.0.6"}
@@ -166,5 +141,4 @@
     assert_raise(ArgumentError){@archetype_id.version_id = nil}
     assert_raise(ArgumentError){@archetype_id.version_id = ""}
->>>>>>> .merge-right.r168
   end
 